<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<!-- forms\tds_configuration.jsp -->
<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean"%>
<%@ taglib uri="/WEB-INF/struts-html.tld" prefix="html"%>
<%@ taglib prefix="change" uri="http://www.telelogic.com/change" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core"%>

<!--tds_configuration.jsp page lets the Admin configure the TDS connection with Change -->

<html:html locale="true">
	<head>
	<link rel="shortcut icon" type="image/ico" href="<change:urlCreator webResource="PTIMAGES"/>RationalChange.ico" >
		<title>
		<change:resource key="ldapConfigPageTitle" bundle="531_patch"/>
		</title>
	
		<style type="text/css">
			<change:wsletExpander>
			 <!-- WSLET CODE=PTInclude -->
			 <!-- PARAM NAME=styles/login.css -->
			 <!-- /WSLET -->
			</change:wsletExpander>
		</style>		
		<script type="text/javascript">
			<change:wsletExpander>
			 <!-- WSLET CODE=PTInclude -->
			 <!-- PARAM NAME=validation.js -->
			 <!-- PARAM NAME=browserDetect.js -->					 
			 <!-- /WSLET -->
			</change:wsletExpander>
			
			var url = "${url}";
			var adminUser = "${adminUser}"
			var password = "${password}";
			var loginAttribute = "${loginAttribute}";
			var searchBase = "${searchBase}";
			var filterCriteria = "${filterCriteria}";
			var groupNameAttribute = "${groupNameAttribute}";
			var groupMemberAttribute = "${groupMemberAttribute}";
			var groupObjectValue = "${groupObjectValue}";
			
			
			function showMessage()
			{
				document.getElementById("warningIcon").style.display = "";
			}				
			
			function validate(objForm)
			{
				document.getElementById("tdsErrMsgId").innerHTML = "";
				document.getElementById("tdsErrMsgId2").innerHTML = "";	
				document.getElementById("warningIcon").style.display = "none";			
				
				var buttonPressed = document.activeElement.getAttribute('value');
				if(buttonPressed=="connect"){					
					document.forms[0].testConnectionEnabled.value = false;
				}
				else{					
					document.forms[0].testConnectionEnabled.value = true;
				}	
				
				
				if((!hasNonWhiteSpaceChar(objForm.url.value)))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapURLRequired' bundle="531_patch" />";
					objForm.password.value="";
					objForm.url.focus();
					objForm.url.select();
					return false;						
				}
				
				
				var url = trim(objForm.url.value);
				
				if ((url).match(/^(ldap[s]?):\/\/([\w.-]+):([1-9]\d*)\/?$/i) == null)
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='wrongLdapUrl'/>";
					objForm.password.value="";
					objForm.url.focus();
					objForm.url.select();
					return false;								
				}
				
				if ((!hasNonWhiteSpaceChar(objForm.user.value)))
				{
					showMessage();			
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapAdminNameRequired' bundle="531_patch"/>";
					objForm.password.value="";
					objForm.user.focus();
					objForm.user.select();
					return false;
				}
				
				if (!hasNonWhiteSpaceChar(objForm.password.value))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='passwordRequired'/>";
					objForm.password.focus();
					return false;
				}
				
				if (!hasNonWhiteSpaceChar(objForm.loginAttribute.value))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapLoginAtttributeRequired' bundle="531_patch"/>";
					objForm.password.focus();
					return false;
				}
				
				if (!hasNonWhiteSpaceChar(objForm.searchBase.value))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapBaseSearchIsRequired' bundle="531_patch"/>";
					objForm.password.focus();
					return false;
				}
				if (!hasNonWhiteSpaceChar(objForm.groupNameAttribute.value))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapGroupNameAttributeRequired' bundle="531_patch"/>";
					objForm.password.focus();
					return false;
				}
				if (!hasNonWhiteSpaceChar(objForm.groupMemberAttribute.value))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapGroupMemberAttributeRequired' bundle="531_patch"/>";
					objForm.password.focus();
					return false;
				}
				if (!hasNonWhiteSpaceChar(objForm.groupObjectValue.value))
				{
					showMessage();
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapGroupObjectValueRequired' bundle="531_patch"/>";
					objForm.password.focus();
					return false;
				}
				
				
				
// 				if (!hasNonWhiteSpaceChar(objForm.filterCriteria.value))  
// 				{
// 					showMessage();
// 					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapFilterReqired' bundle="531_patch"/>";
// 					objForm.password.focus();
// 					return false;
// 				}

				authenticating();
				//apparently setting the action in the html:form doesn't have any impact, so we have to set it.
				document.forms[0].action = "RDSConnectionCheck.do";
							
				BrowserDetect.doSubmitForm(document.forms[0]);
				return false;
			}
			
			function authenticating()
			{
				document.getElementById("authenticating").style.display = "";
				document.forms[0].connect.disabled = true;
				setTimeout('document.images["spinningGif"].src = "<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif"',0);
			}
			
			function load()
			{
				document.forms[0].url.focus();
			}
		</script>
	</head>

	<body style="background-color: white; text-align: center;" onload="load();"> 
	
		<html:form action="RDSConnectionCheck.do" method="post" onsubmit="return validate(this);">
			<input name="methodToCall" type="hidden" value="checkLDAPConnection">
			<table cellspacing="0" cellpadding="2" border="0" style="width: 580px; solid #000066; margin-left: auto; margin-right: auto;">		
				<tr>
					<td style="text-align: left;" colspan="2" class="pageTitle">
						<change:resource key="ldapConfigPageTitle" bundle="531_patch"/>							
					</td>
				</tr>
				<tr style="height: 90px;">
					<td style="text-align: left;" colspan="2" valign="center">
						<change:resource key="ldapConfigMessage" bundle="531_patch"/>
					</td>
				</tr>
				<tr style="height: 50px; vertical-align: top;">
					<td style="width: 20%; text-align: right; padding-right: 8px;">
						<img id="warningIcon" style="display: none;" alt="<change:resource key='altTextWarning'/>" src="<change:urlCreator webResource='PTIMAGES'/>warning_small.gif">							
					</td>
					<td style="width: 80%; text-align: left;">
						<span ID="tdsErrMsgId"></span>
						<br>
						<span ID="tdsErrMsgId2"></span>
					</td>
				</tr>
			</table>
			
			<table id="tdsInputTable" cellspacing="0" cellpadding="2" border="1" style="width: 560px; solid #000066; margin-left: auto; margin-right: auto;">
				<tr>
					<td colspan="2">Primary Directory Server</td>					
				</tr>	
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="url"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="url" size="40" value="${url}" />
					</td>
				</tr>		
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="ldapUserName" bundle="531_patch"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="user" size="40" value="${adminUser}"/>
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="lbl00004"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:password property="password" size="40" value="${password}" />
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="ldapLoginAttribute" bundle="531_patch"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="loginAttribute" size="40" value="${loginAttribute}" />
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="ldapUserBaseSearch" bundle="531_patch"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="searchBase" size="40" value="${searchBase}" />
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B><change:resource key="ldapFilterCriteria" bundle="531_patch"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="filterCriteria" size="40" value="${filterCriteria}" />
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B><change:resource key="ldapSearchSubTree" bundle="531_patch"/></B>
					</td>
					<td align="left" style="width: 30%;" >
						<html:checkbox property="searchSubTree"/>
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="ldapGroupNameAttribute" bundle="531_patch"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="groupNameAttribute" size="40" value="${groupNameAttribute}" />
					</td>					
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="ldapGroupMemberAttribute" bundle="531_patch"/></B>
					</td>					
					<td style="width: 70%; text-align: left;">
						<html:text property="groupMemberAttribute" size="40" value="${groupMemberAttribute}" />
					</td>
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B>* <change:resource key="ldapGroupObjectValue" bundle="531_patch"/></B>
					</td>
					<td style="width: 70%; text-align: left;">
						<html:text property="groupObjectValue" size="40" value="${groupObjectValue}" />
					</td>					
				</tr>
				<tr id="authenticating" style="display :none;">
					<td colspan="2" style="width: 100%; text-align: center; height: 40px; vertical-align: bottom;">
						<img style="padding-right: 8px;" id="spinningGif" src="<change:urlCreator webResource="PTIMAGES"/>spinningWait.gif">
						<change:resource key="authenticating"/>
					</td>
				</tr>							
				<tr style="height: 40px">
				    <td style="text-align: center; vertical-align: bottom;" colspan="2" ><html:submit property="connect" value="connect"><change:resource key="connectButtonLbl"/></html:submit>              <html:submit property="testConn" ><change:resource key='ldapTestConnection' bundle="531_patch"/></html:submit></td>					
				</tr>
				<tr>
					<td style="width: 30%; text-align: right; vertical-align: middle">
						<B><change:resource key="ldapConfigureSecondaryDS" bundle="531_patch"/></B>
					</td>
					<td align="left" style="width: 30%;" >
						<html:checkbox property="configureSecondaryDS"/>
					</td>
				</tr>
			</table>
			
			<html:hidden property="testConnectionEnabled" value="" />						 
		</html:form>
		<html:messages id="msg" message="true">
			<script type="text/javascript">
				showMessage();				
				var pos = "${msg}".search("TCW");				
				if(pos>=0){
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapTestConnectionWarning' bundle="531_patch"/>";
					document.getElementById("tdsErrMsgId2").innerHTML = "${msg}".replace("TCW","");
				}	
				else{
					pos = "${msg}".search("TCS");
					if(pos>=0){
						document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapTestConnectionSuccess' bundle="531_patch"/>";
						document.getElementById("tdsErrMsgId2").innerHTML = "";
					}
					else{
					document.getElementById("tdsErrMsgId").innerHTML = "<change:resource key='ldapConnectionNotEstablished' bundle="531_patch"/>";
					document.getElementById("tdsErrMsgId2").innerHTML = "${msg}";
					}
				}	
			</script>
		</html:messages>
	</body>
</html:html>
